EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_FOCUS_MANAGER_EVENT_REDIRECT_CHANGED =
   EFL_EVENT_DESCRIPTION("redirect,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_FOCUS_MANAGER_EVENT_FLUSH_PRE =
   EFL_EVENT_DESCRIPTION("flush,pre");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_FOCUS_MANAGER_EVENT_COORDS_DIRTY =
   EFL_EVENT_DESCRIPTION("coords,dirty");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_FOCUS_MANAGER_EVENT_MANAGER_FOCUS_CHANGED =
   EFL_EVENT_DESCRIPTION("manager_focus,changed");
EAPI EAPI_WEAK const Efl_Event_Description _EFL_UI_FOCUS_MANAGER_EVENT_DIRTY_LOGIC_FREEZE_CHANGED =
   EFL_EVENT_DESCRIPTION("dirty_logic_freeze,changed");
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_focus_manager_move, Efl_Ui_Focus_Object *, NULL, EFL_FUNC_CALL(direction), Efl_Ui_Focus_Direction direction);
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_focus_manager_request_move, Efl_Ui_Focus_Object *, NULL, EFL_FUNC_CALL(direction, child, logical), Efl_Ui_Focus_Direction direction, Efl_Ui_Focus_Object *child, Eina_Bool logical);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_focus_manager_focus_set, EFL_FUNC_CALL(focus), Efl_Ui_Focus_Object *focus);
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_focus_manager_focus_get, Efl_Ui_Focus_Object *, NULL);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_focus_manager_redirect_set, EFL_FUNC_CALL(redirect), Efl_Ui_Focus_Manager *redirect);
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_focus_manager_redirect_get, Efl_Ui_Focus_Manager *, NULL);
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_focus_manager_border_elements_get, Eina_Iterator *, NULL);

static Eina_Value
__eolian_efl_ui_focus_manager_border_elements_changed_get_reflect(const Eo *obj)
{
   Eina_Bool val = efl_ui_focus_manager_border_elements_changed_get(obj);
   return eina_value_bool_init(val);
}

EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_focus_manager_border_elements_changed_get, Eina_Bool, 0);
EAPI EAPI_WEAK EFL_FUNC_BODYV_CONST(efl_ui_focus_manager_viewport_elements_get, Eina_Iterator *, NULL, EFL_FUNC_CALL(viewport), Eina_Rect viewport);
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_focus_manager_root_set, Eina_Bool, 0, EFL_FUNC_CALL(root), Efl_Ui_Focus_Object *root);
EAPI EAPI_WEAK EFL_FUNC_BODY_CONST(efl_ui_focus_manager_root_get, Efl_Ui_Focus_Object *, NULL);
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_focus_manager_request_subchild, Efl_Ui_Focus_Object *, NULL, EFL_FUNC_CALL(root), Efl_Ui_Focus_Object *root);
EAPI EAPI_WEAK EFL_FUNC_BODYV(efl_ui_focus_manager_fetch, Efl_Ui_Focus_Relations *, NULL, EFL_FUNC_CALL(child), Efl_Ui_Focus_Object *child);
EAPI EAPI_WEAK EFL_FUNC_BODY(efl_ui_focus_manager_logical_end, Efl_Ui_Focus_Manager_Logical_End_Detail, ((Efl_Ui_Focus_Manager_Logical_End_Detail){0}));
EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_ui_focus_manager_reset_history);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_ui_focus_manager_pop_history_stack);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODYV(efl_ui_focus_manager_setup_on_first_touch, EFL_FUNC_CALL(direction, entry), Efl_Ui_Focus_Direction direction, Efl_Ui_Focus_Object *entry);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_ui_focus_manager_dirty_logic_freeze);
EAPI EAPI_WEAK EFL_VOID_FUNC_BODY(efl_ui_focus_manager_dirty_logic_unfreeze);

static Eina_Bool
_efl_ui_focus_manager_class_initializer(Efl_Class *klass)
{
   const Efl_Object_Ops *opsp = NULL;

   const Efl_Object_Property_Reflection_Ops *ropsp = NULL;

#ifndef EFL_UI_FOCUS_MANAGER_EXTRA_OPS
#define EFL_UI_FOCUS_MANAGER_EXTRA_OPS
#endif

   EFL_OPS_DEFINE(ops,
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_move, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_request_move, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_focus_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_focus_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_redirect_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_redirect_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_border_elements_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_border_elements_changed_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_viewport_elements_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_root_set, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_root_get, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_request_subchild, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_fetch, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_logical_end, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_reset_history, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_pop_history_stack, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_setup_on_first_touch, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_dirty_logic_freeze, NULL),
      EFL_OBJECT_OP_FUNC(efl_ui_focus_manager_dirty_logic_unfreeze, NULL),
      EFL_UI_FOCUS_MANAGER_EXTRA_OPS
   );
   opsp = &ops;

   static const Efl_Object_Property_Reflection refl_table[] = {
      {"border_elements_changed", NULL, __eolian_efl_ui_focus_manager_border_elements_changed_get_reflect},
   };
   static const Efl_Object_Property_Reflection_Ops rops = {
      refl_table, EINA_C_ARRAY_LENGTH(refl_table)
   };
   ropsp = &rops;

   return efl_class_functions_set(klass, opsp, ropsp);
}

static const Efl_Class_Description _efl_ui_focus_manager_class_desc = {
   EO_VERSION,
   "Efl.Ui.Focus.Manager",
   EFL_CLASS_TYPE_INTERFACE,
   0,
   _efl_ui_focus_manager_class_initializer,
   NULL,
   NULL
};

EFL_DEFINE_CLASS(efl_ui_focus_manager_interface_get, &_efl_ui_focus_manager_class_desc, NULL, NULL);
